Skip to content

Secure Config

Use the endpoints described below to configure and manage Secure Configuration objects. This abstraction allows system and organization administrations to securely store and manage credentials. Users with lesser permissions can have the credentials shared with them, but be unable to view or edit their contents.

Retrieve a list of secure configuration schemas

Operation path: GET /api/v2/secureConfigSchemas/

Authentication requirements: BearerAuth

Retrieve all secure configuration schemas.

Parameters

Name In Type Required Description
offset query integer false This many results will be skipped.
limit query integer false At most this many results are returned.
orderBy query string false The order to sort the secure configuration schemas. Defaults to the order by the name in descending order.
name query string false Filter for a specific secure configuration schema name.

Enumerated Values

Parameter Value
orderBy [name, -name]

Example responses

200 Response

{
  "properties": {
    "count": {
      "description": "The number of items returned on this page.",
      "type": "integer"
    },
    "data": {
      "description": "The list of secure configuration schemas.",
      "items": {
        "properties": {
          "id": {
            "description": "The ID of the secure configuration.",
            "maxLength": 36,
            "minLength": 32,
            "type": "string"
          },
          "name": {
            "description": "The name of the secure configuration.",
            "type": "string"
          },
          "schemaDefinition": {
            "description": "Secure config schema definition.",
            "properties": {
              "$id": {
                "description": "Secure config schema identifier.",
                "format": "uri",
                "type": "string"
              },
              "$schema": {
                "default": "http://json-schema.org/draft-07/schema#",
                "description": "The JSON schema meta schema version.",
                "enum": [
                  "http://json-schema.org/draft-07/schema#"
                ],
                "type": "string"
              },
              "additionalProperties": {
                "default": false,
                "description": "Allows properties other than schema defined in corresponding secure configs.",
                "type": "boolean"
              },
              "description": {
                "description": "Secure config schema description.",
                "type": "string"
              },
              "properties": {
                "additionalProperties": {
                  "properties": {
                    "description": {
                      "description": "Property description.",
                      "type": "string"
                    },
                    "format": {
                      "description": "Property value format.",
                      "enum": [
                        "uri"
                      ],
                      "type": "string"
                    },
                    "title": {
                      "description": "Property title.",
                      "type": "string"
                    },
                    "type": {
                      "description": "Property type.",
                      "enum": [
                        "string",
                        "array"
                      ],
                      "type": "string"
                    }
                  },
                  "required": [
                    "description",
                    "title",
                    "type"
                  ],
                  "type": "object",
                  "x-versionadded": "v2.36"
                },
                "description": "Secure config properties' definitions.",
                "type": "object"
              },
              "required": {
                "description": "The list of required properties.",
                "items": {
                  "type": "string"
                },
                "type": "array"
              },
              "title": {
                "description": "Secure config schema title.",
                "type": "string"
              },
              "type": {
                "default": "object",
                "description": "Secure config definition type.",
                "enum": [
                  "object"
                ],
                "type": "string"
              }
            },
            "required": [
              "$id",
              "$schema",
              "additionalProperties",
              "description",
              "properties",
              "required",
              "title"
            ],
            "type": "object",
            "x-versionadded": "v2.36"
          }
        },
        "required": [
          "id",
          "name",
          "schemaDefinition"
        ],
        "type": "object",
        "x-versionadded": "v2.36"
      },
      "maxItems": 100,
      "type": "array"
    },
    "next": {
      "description": "The URL of the next page (if null, there is no next page).",
      "format": "uri",
      "type": [
        "string",
        "null"
      ]
    },
    "previous": {
      "description": "The URL of the previous page (if null, there is no previous page).",
      "format": "uri",
      "type": [
        "string",
        "null"
      ]
    },
    "totalCount": {
      "description": "The total number of items across all pages.",
      "type": "integer"
    }
  },
  "required": [
    "data",
    "next",
    "previous",
    "totalCount"
  ],
  "type": "object",
  "x-versionadded": "v2.36"
}

Responses

Status Meaning Description Schema
200 OK The list of secure configuration schemas. SecureConfigSchemaListResponse

Retrieve a secure configuration schema by secure config schema ID

Operation path: GET /api/v2/secureConfigSchemas/{secureConfigSchemaId}/

Authentication requirements: BearerAuth

Retrieve a secure configuration schema.

Parameters

Name In Type Required Description
secureConfigSchemaId path string true The ID of the secure configuration schema.

Example responses

200 Response

{
  "description": "Secure config schema definition.",
  "properties": {
    "$id": {
      "description": "Secure config schema identifier.",
      "format": "uri",
      "type": "string"
    },
    "$schema": {
      "default": "http://json-schema.org/draft-07/schema#",
      "description": "The JSON schema meta schema version.",
      "enum": [
        "http://json-schema.org/draft-07/schema#"
      ],
      "type": "string"
    },
    "additionalProperties": {
      "default": false,
      "description": "Allows properties other than schema defined in corresponding secure configs.",
      "type": "boolean"
    },
    "description": {
      "description": "Secure config schema description.",
      "type": "string"
    },
    "properties": {
      "additionalProperties": {
        "properties": {
          "description": {
            "description": "Property description.",
            "type": "string"
          },
          "format": {
            "description": "Property value format.",
            "enum": [
              "uri"
            ],
            "type": "string"
          },
          "title": {
            "description": "Property title.",
            "type": "string"
          },
          "type": {
            "description": "Property type.",
            "enum": [
              "string",
              "array"
            ],
            "type": "string"
          }
        },
        "required": [
          "description",
          "title",
          "type"
        ],
        "type": "object",
        "x-versionadded": "v2.36"
      },
      "description": "Secure config properties' definitions.",
      "type": "object"
    },
    "required": {
      "description": "The list of required properties.",
      "items": {
        "type": "string"
      },
      "type": "array"
    },
    "title": {
      "description": "Secure config schema title.",
      "type": "string"
    },
    "type": {
      "default": "object",
      "description": "Secure config definition type.",
      "enum": [
        "object"
      ],
      "type": "string"
    }
  },
  "required": [
    "$id",
    "$schema",
    "additionalProperties",
    "description",
    "properties",
    "required",
    "title"
  ],
  "type": "object",
  "x-versionadded": "v2.36"
}

Responses

Status Meaning Description Schema
200 OK The configuration schema. SecureConfigSchema

Retrieve a list of secure configurations

Operation path: GET /api/v2/secureConfigs/

Authentication requirements: BearerAuth

Retrieve all secure configurations.

Parameters

Name In Type Required Description
offset query integer false This many results will be skipped.
limit query integer false At most this many results are returned.
orderBy query string false The order to sort the secure configurations. Defaults to the order by the name in descending order.
name query string false Filter for a specific secure configuration name.
namePart query string false Filter for a secure configuration name.
schemas query string false A comma-separated list of schema names to filter on.

Enumerated Values

Parameter Value
orderBy [name, -name, createdAt, -createdAt]

Example responses

200 Response

{
  "properties": {
    "count": {
      "description": "The number of items returned on this page.",
      "type": "integer"
    },
    "data": {
      "description": "The list of secure configurations.",
      "items": {
        "properties": {
          "createdAt": {
            "description": "When this secure configuration was created.",
            "format": "date-time",
            "type": "string"
          },
          "id": {
            "description": "The ID of the secure configuration.",
            "maxLength": 36,
            "minLength": 32,
            "type": "string"
          },
          "name": {
            "description": "The name of the secure configuration.",
            "type": "string"
          },
          "ownerId": {
            "description": "The ID of the secure configuration owner.",
            "type": "string"
          },
          "schemaName": {
            "description": "The name of the schema used for the secure configuration.",
            "type": "string"
          },
          "valuesHref": {
            "description": "Relative URI that points to the values for this secure configuration.",
            "type": "string"
          }
        },
        "required": [
          "createdAt",
          "id",
          "name",
          "ownerId",
          "schemaName",
          "valuesHref"
        ],
        "type": "object",
        "x-versionadded": "v2.36"
      },
      "maxItems": 100,
      "type": "array"
    },
    "next": {
      "description": "The URL of the next page (if null, there is no next page).",
      "format": "uri",
      "type": [
        "string",
        "null"
      ]
    },
    "previous": {
      "description": "The URL of the previous page (if null, there is no previous page).",
      "format": "uri",
      "type": [
        "string",
        "null"
      ]
    },
    "totalCount": {
      "description": "The total number of items across all pages.",
      "type": "integer"
    }
  },
  "required": [
    "data",
    "next",
    "previous",
    "totalCount"
  ],
  "type": "object",
  "x-versionadded": "v2.36"
}

Responses

Status Meaning Description Schema
200 OK The list of secure configurations. SecureConfigListResponse

Create a secure configuration

Operation path: POST /api/v2/secureConfigs/

Authentication requirements: BearerAuth

Create a secure configuration.

Body parameter

{
  "properties": {
    "name": {
      "description": "The name of the secure configuration.",
      "type": "string"
    },
    "schemaName": {
      "description": "The name of the schema used for validating the secure configuration.",
      "type": "string"
    },
    "values": {
      "description": "The values to associate with the secure configuration.",
      "items": {
        "properties": {
          "key": {
            "description": "The name of the key for the secure configuration value.",
            "type": "string"
          },
          "value": {
            "description": "The value of the secure configuration.",
            "type": "string"
          }
        },
        "required": [
          "key",
          "value"
        ],
        "type": "object",
        "x-versionadded": "v2.36"
      },
      "maxItems": 100,
      "type": "array"
    }
  },
  "required": [
    "name",
    "schemaName",
    "values"
  ],
  "type": "object",
  "x-versionadded": "v2.36"
}

Parameters

Name In Type Required Description
body body SecureConfigCreate false none

Example responses

201 Response

{
  "properties": {
    "createdAt": {
      "description": "When this secure configuration was created.",
      "format": "date-time",
      "type": "string"
    },
    "id": {
      "description": "The ID of the secure configuration.",
      "maxLength": 36,
      "minLength": 32,
      "type": "string"
    },
    "name": {
      "description": "The name of the secure configuration.",
      "type": "string"
    },
    "ownerId": {
      "description": "The ID of the secure configuration owner.",
      "type": "string"
    },
    "schemaName": {
      "description": "The name of the schema used for the secure configuration.",
      "type": "string"
    },
    "valuesHref": {
      "description": "Relative URI that points to the values for this secure configuration.",
      "type": "string"
    }
  },
  "required": [
    "createdAt",
    "id",
    "name",
    "ownerId",
    "schemaName",
    "valuesHref"
  ],
  "type": "object",
  "x-versionadded": "v2.36"
}

Responses

Status Meaning Description Schema
201 Created The created secure configuration. SecureConfigResponse

Delete secure configuration by secure config ID

Operation path: DELETE /api/v2/secureConfigs/{secureConfigId}/

Authentication requirements: BearerAuth

Delete secure configuration and its values.

Parameters

Name In Type Required Description
secureConfigId path string true The ID of the secure configuration.

Responses

Status Meaning Description Schema
204 No Content Secure configuration deleted successfully. None

Retrieve a secure configuration by secure config ID

Operation path: GET /api/v2/secureConfigs/{secureConfigId}/

Authentication requirements: BearerAuth

Retrieve a secure configuration.

Parameters

Name In Type Required Description
secureConfigId path string true The ID of the secure configuration.

Example responses

200 Response

{
  "properties": {
    "createdAt": {
      "description": "When this secure configuration was created.",
      "format": "date-time",
      "type": "string"
    },
    "id": {
      "description": "The ID of the secure configuration.",
      "maxLength": 36,
      "minLength": 32,
      "type": "string"
    },
    "name": {
      "description": "The name of the secure configuration.",
      "type": "string"
    },
    "ownerId": {
      "description": "The ID of the secure configuration owner.",
      "type": "string"
    },
    "schemaName": {
      "description": "The name of the schema used for the secure configuration.",
      "type": "string"
    },
    "valuesHref": {
      "description": "Relative URI that points to the values for this secure configuration.",
      "type": "string"
    }
  },
  "required": [
    "createdAt",
    "id",
    "name",
    "ownerId",
    "schemaName",
    "valuesHref"
  ],
  "type": "object",
  "x-versionadded": "v2.36"
}

Responses

Status Meaning Description Schema
200 OK The secure configuration. SecureConfigResponse

Update a secure configuration by secure config ID

Operation path: PATCH /api/v2/secureConfigs/{secureConfigId}/

Authentication requirements: BearerAuth

Update a secure configuration.

Body parameter

{
  "properties": {
    "name": {
      "description": "The name of the secure configuration.",
      "type": "string"
    },
    "schemaName": {
      "description": "The name of the schema used for validating the secure configuration.",
      "type": [
        "string",
        "null"
      ]
    },
    "values": {
      "description": "The values to associate with the secure configuration.",
      "items": {
        "properties": {
          "key": {
            "description": "The name of the key for the secure configuration value.",
            "type": "string"
          },
          "value": {
            "description": "The value of the secure configuration.",
            "type": "string"
          }
        },
        "required": [
          "key",
          "value"
        ],
        "type": "object",
        "x-versionadded": "v2.36"
      },
      "maxItems": 100,
      "type": "array"
    }
  },
  "type": "object",
  "x-versionadded": "v2.36"
}

Parameters

Name In Type Required Description
secureConfigId path string true The ID of the secure configuration.
body body SecureConfigUpdate false none

Example responses

200 Response

{
  "properties": {
    "createdAt": {
      "description": "When this secure configuration was created.",
      "format": "date-time",
      "type": "string"
    },
    "id": {
      "description": "The ID of the secure configuration.",
      "maxLength": 36,
      "minLength": 32,
      "type": "string"
    },
    "name": {
      "description": "The name of the secure configuration.",
      "type": "string"
    },
    "ownerId": {
      "description": "The ID of the secure configuration owner.",
      "type": "string"
    },
    "schemaName": {
      "description": "The name of the schema used for the secure configuration.",
      "type": "string"
    },
    "valuesHref": {
      "description": "Relative URI that points to the values for this secure configuration.",
      "type": "string"
    }
  },
  "required": [
    "createdAt",
    "id",
    "name",
    "ownerId",
    "schemaName",
    "valuesHref"
  ],
  "type": "object",
  "x-versionadded": "v2.36"
}

Responses

Status Meaning Description Schema
200 OK The updated secure configuration. SecureConfigResponse

Get a list of users, groups, and organizations that have access by secure config ID

Operation path: GET /api/v2/secureConfigs/{secureConfigId}/sharedRoles/

Authentication requirements: BearerAuth

Get a list of users, groups, and organizations that have access to this secure configuration.

Parameters

Name In Type Required Description
offset query integer false This many results will be skipped.
limit query integer false At most this many results are returned.
name query string false Only return roles for a user, group, or organization with this name.
id query string false Only return roles for a user, group, or organization with this ID.
shareRecipientType query string false The recipient type: one of 'user', 'group', or 'organization'.
secureConfigId path string true The ID of the secure configuration.

Enumerated Values

Parameter Value
shareRecipientType [user, group, organization]

Example responses

200 Response

{
  "properties": {
    "count": {
      "description": "The number of items returned on this page.",
      "type": "integer"
    },
    "data": {
      "description": "Details about the Shared Role entries.",
      "items": {
        "properties": {
          "id": {
            "description": "The ID of the recipient.",
            "type": "string"
          },
          "name": {
            "description": "The name of the user, group, or organization.",
            "type": "string"
          },
          "role": {
            "description": "The assigned role",
            "enum": [
              "OWNER",
              "EDITOR",
              "CONSUMER"
            ],
            "type": "string"
          },
          "shareRecipientType": {
            "description": "The recipient type.",
            "enum": [
              "user",
              "group",
              "organization"
            ],
            "type": "string"
          }
        },
        "required": [
          "id",
          "name",
          "role",
          "shareRecipientType"
        ],
        "type": "object",
        "x-versionadded": "v2.36"
      },
      "maxItems": 100,
      "type": "array"
    },
    "next": {
      "description": "The URL of the next page (if null, there is no next page).",
      "format": "uri",
      "type": [
        "string",
        "null"
      ]
    },
    "previous": {
      "description": "The URL of the previous page (if null, there is no previous page).",
      "format": "uri",
      "type": [
        "string",
        "null"
      ]
    },
    "totalCount": {
      "description": "The total number of items across all pages.",
      "type": "integer"
    }
  },
  "required": [
    "data",
    "next",
    "previous",
    "totalCount"
  ],
  "type": "object",
  "x-versionadded": "v2.36"
}

Responses

Status Meaning Description Schema
200 OK none SecureConfigSharedRolesList

Share a secure configuration by secure config ID

Operation path: PATCH /api/v2/secureConfigs/{secureConfigId}/sharedRoles/

Authentication requirements: BearerAuth

Share a secure configuration with a user, group or organization.

Body parameter

{
  "properties": {
    "roles": {
      "description": "An array of RoleRequest objects. May contain at most 100 such objects.",
      "items": {
        "oneOf": [
          {
            "properties": {
              "canShare": {
                "description": "Whether the org/group/user should be able to share with others.If true, the org/group/user will be able to grant any role up to and includingtheir own to other orgs/groups/user. If `role` is `NO_ROLE` `canShare` is ignored.",
                "type": "boolean"
              },
              "role": {
                "description": "The role of the recipient on this entity. One of OWNER, EDITOR, CONSUMER.",
                "enum": [
                  "OWNER",
                  "EDITOR",
                  "CONSUMER",
                  "NO_ROLE"
                ],
                "type": "string"
              },
              "shareRecipientType": {
                "description": "Describes the recipient type, either user, group, or organization.",
                "enum": [
                  "user",
                  "group",
                  "organization"
                ],
                "type": "string"
              },
              "username": {
                "description": "Username of the user to update the access role for.",
                "type": "string"
              }
            },
            "required": [
              "role",
              "shareRecipientType",
              "username"
            ],
            "type": "object",
            "x-versionadded": "v2.36"
          },
          {
            "properties": {
              "canShare": {
                "description": "Whether the org/group/user should be able to share with others.If true, the org/group/user will be able to grant any role up to and includingtheir own to other orgs/groups/user. If `role` is `NO_ROLE` `canShare` is ignored.",
                "type": "boolean"
              },
              "id": {
                "description": "The ID of the recipient.",
                "type": "string"
              },
              "role": {
                "description": "The role of the recipient on this entity. One of OWNER, EDITOR, CONSUMER.",
                "enum": [
                  "OWNER",
                  "EDITOR",
                  "CONSUMER",
                  "NO_ROLE"
                ],
                "type": "string"
              },
              "shareRecipientType": {
                "description": "Describes the recipient type, either user, group, or organization.",
                "enum": [
                  "user",
                  "group",
                  "organization"
                ],
                "type": "string"
              }
            },
            "required": [
              "id",
              "role",
              "shareRecipientType"
            ],
            "type": "object",
            "x-versionadded": "v2.36"
          }
        ]
      },
      "maxItems": 100,
      "minItems": 1,
      "type": "array"
    }
  },
  "required": [
    "roles"
  ],
  "type": "object",
  "x-versionadded": "v2.36"
}

Parameters

Name In Type Required Description
secureConfigId path string true The ID of the secure configuration.
body body SecureConfigSharingUpdate false none

Responses

Status Meaning Description Schema
204 No Content The roles were updated successfully. None
422 Unprocessable Entity The request was formatted improperly. None

Retrieve a list of values by secure config ID

Operation path: GET /api/v2/secureConfigs/{secureConfigId}/values/

Authentication requirements: BearerAuth

Retrieve all values created for the secure configuration.

Parameters

Name In Type Required Description
secureConfigId path string true The ID of the secure configuration.

Example responses

200 Response

{
  "properties": {
    "secureConfigId": {
      "description": "The ID of the SecureConfig.",
      "maxLength": 36,
      "minLength": 32,
      "type": "string"
    },
    "values": {
      "description": "The secure configuration values.",
      "items": {
        "properties": {
          "key": {
            "description": "The name of the key for the secure configuration value.",
            "type": "string"
          },
          "value": {
            "description": "The value of the secure configuration.",
            "type": "string"
          }
        },
        "required": [
          "key",
          "value"
        ],
        "type": "object",
        "x-versionadded": "v2.36"
      },
      "type": "array"
    }
  },
  "required": [
    "secureConfigId",
    "values"
  ],
  "type": "object",
  "x-versionadded": "v2.36"
}

Responses

Status Meaning Description Schema
200 OK A list of values for the secure configuration. SecureConfigListValuesResponse

Schemas

SecureConfigCreate

{
  "properties": {
    "name": {
      "description": "The name of the secure configuration.",
      "type": "string"
    },
    "schemaName": {
      "description": "The name of the schema used for validating the secure configuration.",
      "type": "string"
    },
    "values": {
      "description": "The values to associate with the secure configuration.",
      "items": {
        "properties": {
          "key": {
            "description": "The name of the key for the secure configuration value.",
            "type": "string"
          },
          "value": {
            "description": "The value of the secure configuration.",
            "type": "string"
          }
        },
        "required": [
          "key",
          "value"
        ],
        "type": "object",
        "x-versionadded": "v2.36"
      },
      "maxItems": 100,
      "type": "array"
    }
  },
  "required": [
    "name",
    "schemaName",
    "values"
  ],
  "type": "object",
  "x-versionadded": "v2.36"
}

Properties

Name Type Required Restrictions Description
name string true The name of the secure configuration.
schemaName string true The name of the schema used for validating the secure configuration.
values [SecureConfigKeyValue] true maxItems: 100
The values to associate with the secure configuration.

SecureConfigGrantAccessControlWithIdWithGrantValidators

{
  "properties": {
    "canShare": {
      "description": "Whether the org/group/user should be able to share with others.If true, the org/group/user will be able to grant any role up to and includingtheir own to other orgs/groups/user. If `role` is `NO_ROLE` `canShare` is ignored.",
      "type": "boolean"
    },
    "id": {
      "description": "The ID of the recipient.",
      "type": "string"
    },
    "role": {
      "description": "The role of the recipient on this entity. One of OWNER, EDITOR, CONSUMER.",
      "enum": [
        "OWNER",
        "EDITOR",
        "CONSUMER",
        "NO_ROLE"
      ],
      "type": "string"
    },
    "shareRecipientType": {
      "description": "Describes the recipient type, either user, group, or organization.",
      "enum": [
        "user",
        "group",
        "organization"
      ],
      "type": "string"
    }
  },
  "required": [
    "id",
    "role",
    "shareRecipientType"
  ],
  "type": "object",
  "x-versionadded": "v2.36"
}

Properties

Name Type Required Restrictions Description
canShare boolean false Whether the org/group/user should be able to share with others.If true, the org/group/user will be able to grant any role up to and includingtheir own to other orgs/groups/user. If role is NO_ROLE canShare is ignored.
id string true The ID of the recipient.
role string true The role of the recipient on this entity. One of OWNER, EDITOR, CONSUMER.
shareRecipientType string true Describes the recipient type, either user, group, or organization.

Enumerated Values

Property Value
role [OWNER, EDITOR, CONSUMER, NO_ROLE]
shareRecipientType [user, group, organization]

SecureConfigGrantAccessControlWithUsernameWithGrantValidators

{
  "properties": {
    "canShare": {
      "description": "Whether the org/group/user should be able to share with others.If true, the org/group/user will be able to grant any role up to and includingtheir own to other orgs/groups/user. If `role` is `NO_ROLE` `canShare` is ignored.",
      "type": "boolean"
    },
    "role": {
      "description": "The role of the recipient on this entity. One of OWNER, EDITOR, CONSUMER.",
      "enum": [
        "OWNER",
        "EDITOR",
        "CONSUMER",
        "NO_ROLE"
      ],
      "type": "string"
    },
    "shareRecipientType": {
      "description": "Describes the recipient type, either user, group, or organization.",
      "enum": [
        "user",
        "group",
        "organization"
      ],
      "type": "string"
    },
    "username": {
      "description": "Username of the user to update the access role for.",
      "type": "string"
    }
  },
  "required": [
    "role",
    "shareRecipientType",
    "username"
  ],
  "type": "object",
  "x-versionadded": "v2.36"
}

Properties

Name Type Required Restrictions Description
canShare boolean false Whether the org/group/user should be able to share with others.If true, the org/group/user will be able to grant any role up to and includingtheir own to other orgs/groups/user. If role is NO_ROLE canShare is ignored.
role string true The role of the recipient on this entity. One of OWNER, EDITOR, CONSUMER.
shareRecipientType string true Describes the recipient type, either user, group, or organization.
username string true Username of the user to update the access role for.

Enumerated Values

Property Value
role [OWNER, EDITOR, CONSUMER, NO_ROLE]
shareRecipientType [user, group, organization]

SecureConfigKeyValue

{
  "properties": {
    "key": {
      "description": "The name of the key for the secure configuration value.",
      "type": "string"
    },
    "value": {
      "description": "The value of the secure configuration.",
      "type": "string"
    }
  },
  "required": [
    "key",
    "value"
  ],
  "type": "object",
  "x-versionadded": "v2.36"
}

Properties

Name Type Required Restrictions Description
key string true The name of the key for the secure configuration value.
value string true The value of the secure configuration.

SecureConfigListResponse

{
  "properties": {
    "count": {
      "description": "The number of items returned on this page.",
      "type": "integer"
    },
    "data": {
      "description": "The list of secure configurations.",
      "items": {
        "properties": {
          "createdAt": {
            "description": "When this secure configuration was created.",
            "format": "date-time",
            "type": "string"
          },
          "id": {
            "description": "The ID of the secure configuration.",
            "maxLength": 36,
            "minLength": 32,
            "type": "string"
          },
          "name": {
            "description": "The name of the secure configuration.",
            "type": "string"
          },
          "ownerId": {
            "description": "The ID of the secure configuration owner.",
            "type": "string"
          },
          "schemaName": {
            "description": "The name of the schema used for the secure configuration.",
            "type": "string"
          },
          "valuesHref": {
            "description": "Relative URI that points to the values for this secure configuration.",
            "type": "string"
          }
        },
        "required": [
          "createdAt",
          "id",
          "name",
          "ownerId",
          "schemaName",
          "valuesHref"
        ],
        "type": "object",
        "x-versionadded": "v2.36"
      },
      "maxItems": 100,
      "type": "array"
    },
    "next": {
      "description": "The URL of the next page (if null, there is no next page).",
      "format": "uri",
      "type": [
        "string",
        "null"
      ]
    },
    "previous": {
      "description": "The URL of the previous page (if null, there is no previous page).",
      "format": "uri",
      "type": [
        "string",
        "null"
      ]
    },
    "totalCount": {
      "description": "The total number of items across all pages.",
      "type": "integer"
    }
  },
  "required": [
    "data",
    "next",
    "previous",
    "totalCount"
  ],
  "type": "object",
  "x-versionadded": "v2.36"
}

Properties

Name Type Required Restrictions Description
count integer false The number of items returned on this page.
data [SecureConfigResponse] true maxItems: 100
The list of secure configurations.
next string,null(uri) true The URL of the next page (if null, there is no next page).
previous string,null(uri) true The URL of the previous page (if null, there is no previous page).
totalCount integer true The total number of items across all pages.

SecureConfigListValuesResponse

{
  "properties": {
    "secureConfigId": {
      "description": "The ID of the SecureConfig.",
      "maxLength": 36,
      "minLength": 32,
      "type": "string"
    },
    "values": {
      "description": "The secure configuration values.",
      "items": {
        "properties": {
          "key": {
            "description": "The name of the key for the secure configuration value.",
            "type": "string"
          },
          "value": {
            "description": "The value of the secure configuration.",
            "type": "string"
          }
        },
        "required": [
          "key",
          "value"
        ],
        "type": "object",
        "x-versionadded": "v2.36"
      },
      "type": "array"
    }
  },
  "required": [
    "secureConfigId",
    "values"
  ],
  "type": "object",
  "x-versionadded": "v2.36"
}

Properties

Name Type Required Restrictions Description
secureConfigId string true maxLength: 36
minLength: 32
minLength: 32
The ID of the SecureConfig.
values [SecureConfigKeyValue] true The secure configuration values.

SecureConfigResponse

{
  "properties": {
    "createdAt": {
      "description": "When this secure configuration was created.",
      "format": "date-time",
      "type": "string"
    },
    "id": {
      "description": "The ID of the secure configuration.",
      "maxLength": 36,
      "minLength": 32,
      "type": "string"
    },
    "name": {
      "description": "The name of the secure configuration.",
      "type": "string"
    },
    "ownerId": {
      "description": "The ID of the secure configuration owner.",
      "type": "string"
    },
    "schemaName": {
      "description": "The name of the schema used for the secure configuration.",
      "type": "string"
    },
    "valuesHref": {
      "description": "Relative URI that points to the values for this secure configuration.",
      "type": "string"
    }
  },
  "required": [
    "createdAt",
    "id",
    "name",
    "ownerId",
    "schemaName",
    "valuesHref"
  ],
  "type": "object",
  "x-versionadded": "v2.36"
}

Properties

Name Type Required Restrictions Description
createdAt string(date-time) true When this secure configuration was created.
id string true maxLength: 36
minLength: 32
minLength: 32
The ID of the secure configuration.
name string true The name of the secure configuration.
ownerId string true The ID of the secure configuration owner.
schemaName string true The name of the schema used for the secure configuration.
valuesHref string true Relative URI that points to the values for this secure configuration.

SecureConfigSchema

{
  "description": "Secure config schema definition.",
  "properties": {
    "$id": {
      "description": "Secure config schema identifier.",
      "format": "uri",
      "type": "string"
    },
    "$schema": {
      "default": "http://json-schema.org/draft-07/schema#",
      "description": "The JSON schema meta schema version.",
      "enum": [
        "http://json-schema.org/draft-07/schema#"
      ],
      "type": "string"
    },
    "additionalProperties": {
      "default": false,
      "description": "Allows properties other than schema defined in corresponding secure configs.",
      "type": "boolean"
    },
    "description": {
      "description": "Secure config schema description.",
      "type": "string"
    },
    "properties": {
      "additionalProperties": {
        "properties": {
          "description": {
            "description": "Property description.",
            "type": "string"
          },
          "format": {
            "description": "Property value format.",
            "enum": [
              "uri"
            ],
            "type": "string"
          },
          "title": {
            "description": "Property title.",
            "type": "string"
          },
          "type": {
            "description": "Property type.",
            "enum": [
              "string",
              "array"
            ],
            "type": "string"
          }
        },
        "required": [
          "description",
          "title",
          "type"
        ],
        "type": "object",
        "x-versionadded": "v2.36"
      },
      "description": "Secure config properties' definitions.",
      "type": "object"
    },
    "required": {
      "description": "The list of required properties.",
      "items": {
        "type": "string"
      },
      "type": "array"
    },
    "title": {
      "description": "Secure config schema title.",
      "type": "string"
    },
    "type": {
      "default": "object",
      "description": "Secure config definition type.",
      "enum": [
        "object"
      ],
      "type": "string"
    }
  },
  "required": [
    "$id",
    "$schema",
    "additionalProperties",
    "description",
    "properties",
    "required",
    "title"
  ],
  "type": "object",
  "x-versionadded": "v2.36"
}

Secure config schema definition.

Properties

Name Type Required Restrictions Description
$id string(uri) true Secure config schema identifier.
$schema string true The JSON schema meta schema version.
additionalProperties boolean true Allows properties other than schema defined in corresponding secure configs.
description string true Secure config schema description.
properties object true Secure config properties' definitions.
» additionalProperties SecureConfigSchemaProperty false none
required [string] true The list of required properties.
title string true Secure config schema title.
type string false Secure config definition type.

Enumerated Values

Property Value
$schema http://json-schema.org/draft-07/schema#
type object

SecureConfigSchemaListResponse

{
  "properties": {
    "count": {
      "description": "The number of items returned on this page.",
      "type": "integer"
    },
    "data": {
      "description": "The list of secure configuration schemas.",
      "items": {
        "properties": {
          "id": {
            "description": "The ID of the secure configuration.",
            "maxLength": 36,
            "minLength": 32,
            "type": "string"
          },
          "name": {
            "description": "The name of the secure configuration.",
            "type": "string"
          },
          "schemaDefinition": {
            "description": "Secure config schema definition.",
            "properties": {
              "$id": {
                "description": "Secure config schema identifier.",
                "format": "uri",
                "type": "string"
              },
              "$schema": {
                "default": "http://json-schema.org/draft-07/schema#",
                "description": "The JSON schema meta schema version.",
                "enum": [
                  "http://json-schema.org/draft-07/schema#"
                ],
                "type": "string"
              },
              "additionalProperties": {
                "default": false,
                "description": "Allows properties other than schema defined in corresponding secure configs.",
                "type": "boolean"
              },
              "description": {
                "description": "Secure config schema description.",
                "type": "string"
              },
              "properties": {
                "additionalProperties": {
                  "properties": {
                    "description": {
                      "description": "Property description.",
                      "type": "string"
                    },
                    "format": {
                      "description": "Property value format.",
                      "enum": [
                        "uri"
                      ],
                      "type": "string"
                    },
                    "title": {
                      "description": "Property title.",
                      "type": "string"
                    },
                    "type": {
                      "description": "Property type.",
                      "enum": [
                        "string",
                        "array"
                      ],
                      "type": "string"
                    }
                  },
                  "required": [
                    "description",
                    "title",
                    "type"
                  ],
                  "type": "object",
                  "x-versionadded": "v2.36"
                },
                "description": "Secure config properties' definitions.",
                "type": "object"
              },
              "required": {
                "description": "The list of required properties.",
                "items": {
                  "type": "string"
                },
                "type": "array"
              },
              "title": {
                "description": "Secure config schema title.",
                "type": "string"
              },
              "type": {
                "default": "object",
                "description": "Secure config definition type.",
                "enum": [
                  "object"
                ],
                "type": "string"
              }
            },
            "required": [
              "$id",
              "$schema",
              "additionalProperties",
              "description",
              "properties",
              "required",
              "title"
            ],
            "type": "object",
            "x-versionadded": "v2.36"
          }
        },
        "required": [
          "id",
          "name",
          "schemaDefinition"
        ],
        "type": "object",
        "x-versionadded": "v2.36"
      },
      "maxItems": 100,
      "type": "array"
    },
    "next": {
      "description": "The URL of the next page (if null, there is no next page).",
      "format": "uri",
      "type": [
        "string",
        "null"
      ]
    },
    "previous": {
      "description": "The URL of the previous page (if null, there is no previous page).",
      "format": "uri",
      "type": [
        "string",
        "null"
      ]
    },
    "totalCount": {
      "description": "The total number of items across all pages.",
      "type": "integer"
    }
  },
  "required": [
    "data",
    "next",
    "previous",
    "totalCount"
  ],
  "type": "object",
  "x-versionadded": "v2.36"
}

Properties

Name Type Required Restrictions Description
count integer false The number of items returned on this page.
data [SecureConfigSchemaResponse] true maxItems: 100
The list of secure configuration schemas.
next string,null(uri) true The URL of the next page (if null, there is no next page).
previous string,null(uri) true The URL of the previous page (if null, there is no previous page).
totalCount integer true The total number of items across all pages.

SecureConfigSchemaProperty

{
  "properties": {
    "description": {
      "description": "Property description.",
      "type": "string"
    },
    "format": {
      "description": "Property value format.",
      "enum": [
        "uri"
      ],
      "type": "string"
    },
    "title": {
      "description": "Property title.",
      "type": "string"
    },
    "type": {
      "description": "Property type.",
      "enum": [
        "string",
        "array"
      ],
      "type": "string"
    }
  },
  "required": [
    "description",
    "title",
    "type"
  ],
  "type": "object",
  "x-versionadded": "v2.36"
}

Properties

Name Type Required Restrictions Description
description string true Property description.
format string false Property value format.
title string true Property title.
type string true Property type.

Enumerated Values

Property Value
format uri
type [string, array]

SecureConfigSchemaResponse

{
  "properties": {
    "id": {
      "description": "The ID of the secure configuration.",
      "maxLength": 36,
      "minLength": 32,
      "type": "string"
    },
    "name": {
      "description": "The name of the secure configuration.",
      "type": "string"
    },
    "schemaDefinition": {
      "description": "Secure config schema definition.",
      "properties": {
        "$id": {
          "description": "Secure config schema identifier.",
          "format": "uri",
          "type": "string"
        },
        "$schema": {
          "default": "http://json-schema.org/draft-07/schema#",
          "description": "The JSON schema meta schema version.",
          "enum": [
            "http://json-schema.org/draft-07/schema#"
          ],
          "type": "string"
        },
        "additionalProperties": {
          "default": false,
          "description": "Allows properties other than schema defined in corresponding secure configs.",
          "type": "boolean"
        },
        "description": {
          "description": "Secure config schema description.",
          "type": "string"
        },
        "properties": {
          "additionalProperties": {
            "properties": {
              "description": {
                "description": "Property description.",
                "type": "string"
              },
              "format": {
                "description": "Property value format.",
                "enum": [
                  "uri"
                ],
                "type": "string"
              },
              "title": {
                "description": "Property title.",
                "type": "string"
              },
              "type": {
                "description": "Property type.",
                "enum": [
                  "string",
                  "array"
                ],
                "type": "string"
              }
            },
            "required": [
              "description",
              "title",
              "type"
            ],
            "type": "object",
            "x-versionadded": "v2.36"
          },
          "description": "Secure config properties' definitions.",
          "type": "object"
        },
        "required": {
          "description": "The list of required properties.",
          "items": {
            "type": "string"
          },
          "type": "array"
        },
        "title": {
          "description": "Secure config schema title.",
          "type": "string"
        },
        "type": {
          "default": "object",
          "description": "Secure config definition type.",
          "enum": [
            "object"
          ],
          "type": "string"
        }
      },
      "required": [
        "$id",
        "$schema",
        "additionalProperties",
        "description",
        "properties",
        "required",
        "title"
      ],
      "type": "object",
      "x-versionadded": "v2.36"
    }
  },
  "required": [
    "id",
    "name",
    "schemaDefinition"
  ],
  "type": "object",
  "x-versionadded": "v2.36"
}

Properties

Name Type Required Restrictions Description
id string true maxLength: 36
minLength: 32
minLength: 32
The ID of the secure configuration.
name string true The name of the secure configuration.
schemaDefinition SecureConfigSchema true Secure config schema definition.

SecureConfigSharedRolesEntry

{
  "properties": {
    "id": {
      "description": "The ID of the recipient.",
      "type": "string"
    },
    "name": {
      "description": "The name of the user, group, or organization.",
      "type": "string"
    },
    "role": {
      "description": "The assigned role",
      "enum": [
        "OWNER",
        "EDITOR",
        "CONSUMER"
      ],
      "type": "string"
    },
    "shareRecipientType": {
      "description": "The recipient type.",
      "enum": [
        "user",
        "group",
        "organization"
      ],
      "type": "string"
    }
  },
  "required": [
    "id",
    "name",
    "role",
    "shareRecipientType"
  ],
  "type": "object",
  "x-versionadded": "v2.36"
}

Properties

Name Type Required Restrictions Description
id string true The ID of the recipient.
name string true The name of the user, group, or organization.
role string true The assigned role
shareRecipientType string true The recipient type.

Enumerated Values

Property Value
role [OWNER, EDITOR, CONSUMER]
shareRecipientType [user, group, organization]

SecureConfigSharedRolesList

{
  "properties": {
    "count": {
      "description": "The number of items returned on this page.",
      "type": "integer"
    },
    "data": {
      "description": "Details about the Shared Role entries.",
      "items": {
        "properties": {
          "id": {
            "description": "The ID of the recipient.",
            "type": "string"
          },
          "name": {
            "description": "The name of the user, group, or organization.",
            "type": "string"
          },
          "role": {
            "description": "The assigned role",
            "enum": [
              "OWNER",
              "EDITOR",
              "CONSUMER"
            ],
            "type": "string"
          },
          "shareRecipientType": {
            "description": "The recipient type.",
            "enum": [
              "user",
              "group",
              "organization"
            ],
            "type": "string"
          }
        },
        "required": [
          "id",
          "name",
          "role",
          "shareRecipientType"
        ],
        "type": "object",
        "x-versionadded": "v2.36"
      },
      "maxItems": 100,
      "type": "array"
    },
    "next": {
      "description": "The URL of the next page (if null, there is no next page).",
      "format": "uri",
      "type": [
        "string",
        "null"
      ]
    },
    "previous": {
      "description": "The URL of the previous page (if null, there is no previous page).",
      "format": "uri",
      "type": [
        "string",
        "null"
      ]
    },
    "totalCount": {
      "description": "The total number of items across all pages.",
      "type": "integer"
    }
  },
  "required": [
    "data",
    "next",
    "previous",
    "totalCount"
  ],
  "type": "object",
  "x-versionadded": "v2.36"
}

Properties

Name Type Required Restrictions Description
count integer false The number of items returned on this page.
data [SecureConfigSharedRolesEntry] true maxItems: 100
Details about the Shared Role entries.
next string,null(uri) true The URL of the next page (if null, there is no next page).
previous string,null(uri) true The URL of the previous page (if null, there is no previous page).
totalCount integer true The total number of items across all pages.

SecureConfigSharingUpdate

{
  "properties": {
    "roles": {
      "description": "An array of RoleRequest objects. May contain at most 100 such objects.",
      "items": {
        "oneOf": [
          {
            "properties": {
              "canShare": {
                "description": "Whether the org/group/user should be able to share with others.If true, the org/group/user will be able to grant any role up to and includingtheir own to other orgs/groups/user. If `role` is `NO_ROLE` `canShare` is ignored.",
                "type": "boolean"
              },
              "role": {
                "description": "The role of the recipient on this entity. One of OWNER, EDITOR, CONSUMER.",
                "enum": [
                  "OWNER",
                  "EDITOR",
                  "CONSUMER",
                  "NO_ROLE"
                ],
                "type": "string"
              },
              "shareRecipientType": {
                "description": "Describes the recipient type, either user, group, or organization.",
                "enum": [
                  "user",
                  "group",
                  "organization"
                ],
                "type": "string"
              },
              "username": {
                "description": "Username of the user to update the access role for.",
                "type": "string"
              }
            },
            "required": [
              "role",
              "shareRecipientType",
              "username"
            ],
            "type": "object",
            "x-versionadded": "v2.36"
          },
          {
            "properties": {
              "canShare": {
                "description": "Whether the org/group/user should be able to share with others.If true, the org/group/user will be able to grant any role up to and includingtheir own to other orgs/groups/user. If `role` is `NO_ROLE` `canShare` is ignored.",
                "type": "boolean"
              },
              "id": {
                "description": "The ID of the recipient.",
                "type": "string"
              },
              "role": {
                "description": "The role of the recipient on this entity. One of OWNER, EDITOR, CONSUMER.",
                "enum": [
                  "OWNER",
                  "EDITOR",
                  "CONSUMER",
                  "NO_ROLE"
                ],
                "type": "string"
              },
              "shareRecipientType": {
                "description": "Describes the recipient type, either user, group, or organization.",
                "enum": [
                  "user",
                  "group",
                  "organization"
                ],
                "type": "string"
              }
            },
            "required": [
              "id",
              "role",
              "shareRecipientType"
            ],
            "type": "object",
            "x-versionadded": "v2.36"
          }
        ]
      },
      "maxItems": 100,
      "minItems": 1,
      "type": "array"
    }
  },
  "required": [
    "roles"
  ],
  "type": "object",
  "x-versionadded": "v2.36"
}

Properties

Name Type Required Restrictions Description
roles [oneOf] true maxItems: 100
minItems: 1
An array of RoleRequest objects. May contain at most 100 such objects.

oneOf

Name Type Required Restrictions Description
» anonymous SecureConfigGrantAccessControlWithUsernameWithGrantValidators false none

xor

Name Type Required Restrictions Description
» anonymous SecureConfigGrantAccessControlWithIdWithGrantValidators false none

SecureConfigUpdate

{
  "properties": {
    "name": {
      "description": "The name of the secure configuration.",
      "type": "string"
    },
    "schemaName": {
      "description": "The name of the schema used for validating the secure configuration.",
      "type": [
        "string",
        "null"
      ]
    },
    "values": {
      "description": "The values to associate with the secure configuration.",
      "items": {
        "properties": {
          "key": {
            "description": "The name of the key for the secure configuration value.",
            "type": "string"
          },
          "value": {
            "description": "The value of the secure configuration.",
            "type": "string"
          }
        },
        "required": [
          "key",
          "value"
        ],
        "type": "object",
        "x-versionadded": "v2.36"
      },
      "maxItems": 100,
      "type": "array"
    }
  },
  "type": "object",
  "x-versionadded": "v2.36"
}

Properties

Name Type Required Restrictions Description
name string false The name of the secure configuration.
schemaName string,null false The name of the schema used for validating the secure configuration.
values [SecureConfigKeyValue] false maxItems: 100
The values to associate with the secure configuration.